/* gitg-date.c generated by valac 0.42.3, the Vala compiler
 * generated from gitg-date.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2013 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gdesktop-enums.h>


#define GITG_TYPE_DATE (gitg_date_get_type ())
#define GITG_DATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GITG_TYPE_DATE, GitgDate))
#define GITG_DATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GITG_TYPE_DATE, GitgDateClass))
#define GITG_IS_DATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GITG_TYPE_DATE))
#define GITG_IS_DATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GITG_TYPE_DATE))
#define GITG_DATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GITG_TYPE_DATE, GitgDateClass))

typedef struct _GitgDate GitgDate;
typedef struct _GitgDateClass GitgDateClass;
typedef struct _GitgDatePrivate GitgDatePrivate;
enum  {
	GITG_DATE_0_PROPERTY,
	GITG_DATE_DATE_STRING_PROPERTY,
	GITG_DATE_DATE_PROPERTY,
	GITG_DATE_NUM_PROPERTIES
};
static GParamSpec* gitg_date_properties[GITG_DATE_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_settings_schema_source_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_source_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	GITG_DATE_ERROR_INVALID_FORMAT
} GitgDateError;
#define GITG_DATE_ERROR gitg_date_error_quark ()
struct _GitgDate {
	GObject parent_instance;
	GitgDatePrivate * priv;
};

struct _GitgDateClass {
	GObjectClass parent_class;
};

struct _GitgDatePrivate {
	GDateTime* d_datetime;
	gchar* _date_string;
};


static gint GitgDate_private_offset;
static gpointer gitg_date_parent_class = NULL;
static GRegex* gitg_date_s_rfc2822;
static GRegex* gitg_date_s_rfc2822 = NULL;
static GRegex* gitg_date_s_iso8601;
static GRegex* gitg_date_s_iso8601 = NULL;
static GRegex* gitg_date_s_internal;
static GRegex* gitg_date_s_internal = NULL;
static GSettings* gitg_date_s_gnome_interface_settings;
static GSettings* gitg_date_s_gnome_interface_settings = NULL;
static gboolean gitg_date_s_tried_gnome_interface_settings;
static gboolean gitg_date_s_tried_gnome_interface_settings = FALSE;
static gchar** gitg_date_s_months;
static gint gitg_date_s_months_length1;
static gchar** gitg_date_s_months = NULL;
static gint gitg_date_s_months_length1 = 0;
static gint _gitg_date_s_months_size_ = 0;
static GInitableIface * gitg_date_g_initable_parent_iface = NULL;

GQuark gitg_date_error_quark (void);
GType gitg_date_get_type (void) G_GNUC_CONST;
static gboolean gitg_date_fetch_and_set_int (GMatchInfo* info,
                                      const gchar* name,
                                      gint* retval);
static gboolean gitg_date_fetch_and_set_double (GMatchInfo* info,
                                         const gchar* name,
                                         gdouble* retval);
static GDateTime* gitg_date_parse_internal (GMatchInfo* info,
                                     GError** error);
static GDateTime* gitg_date_parse_iso8601 (GMatchInfo* info,
                                    GError** error);
static GDateTime* gitg_date_parse_rfc2822 (GMatchInfo* info,
                                    GError** error);
static gboolean gitg_date_real_init (GInitable* base,
                              GCancellable* cancellable,
                              GError** error);
const gchar* gitg_date_get_date_string (GitgDate* self);
GitgDate* gitg_date_new (const gchar* date,
                         GError** error);
GitgDate* gitg_date_construct (GType object_type,
                               const gchar* date,
                               GError** error);
gchar* gitg_date_for_display (GitgDate* self);
static gboolean gitg_date_get_is_24h (GitgDate* self);
GitgDate* gitg_date_new_for_date_time (GDateTime* dt);
GitgDate* gitg_date_construct_for_date_time (GType object_type,
                                             GDateTime* dt);
GDateTime* gitg_date_parse (const gchar* date,
                            GError** error);
GDateTime* gitg_date_get_date (GitgDate* self);
void gitg_date_set_date_string (GitgDate* self,
                                const gchar* value);
static void gitg_date_finalize (GObject * obj);
static void _vala_gitg_date_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_gitg_date_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);


GQuark
gitg_date_error_quark (void)
{
	return g_quark_from_static_string ("gitg_date_error-quark");
}


static inline gpointer
gitg_date_get_instance_private (GitgDate* self)
{
	return G_STRUCT_MEMBER_P (self, GitgDate_private_offset);
}


static gboolean
gitg_date_fetch_and_set_int (GMatchInfo* info,
                             const gchar* name,
                             gint* retval)
{
	gboolean result = FALSE;
	gchar* val = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 139 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 139 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 141 "../libgitg/gitg-date.vala"
	_tmp0_ = g_match_info_fetch_named (info, name);
#line 141 "../libgitg/gitg-date.vala"
	val = _tmp0_;
#line 143 "../libgitg/gitg-date.vala"
	_tmp1_ = val;
#line 143 "../libgitg/gitg-date.vala"
	if (_tmp1_ == NULL) {
#line 145 "../libgitg/gitg-date.vala"
		result = FALSE;
#line 145 "../libgitg/gitg-date.vala"
		_g_free0 (val);
#line 145 "../libgitg/gitg-date.vala"
		return result;
#line 187 "gitg-date.c"
	}
#line 148 "../libgitg/gitg-date.vala"
	_tmp2_ = val;
#line 148 "../libgitg/gitg-date.vala"
	*retval = atoi (_tmp2_);
#line 149 "../libgitg/gitg-date.vala"
	result = TRUE;
#line 149 "../libgitg/gitg-date.vala"
	_g_free0 (val);
#line 149 "../libgitg/gitg-date.vala"
	return result;
#line 199 "gitg-date.c"
}


static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
	gdouble _tmp0_;
#line 944 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 945 "glib-2.0.vapi"
	_tmp0_ = g_ascii_strtod (str, NULL);
#line 945 "glib-2.0.vapi"
	result = _tmp0_;
#line 945 "glib-2.0.vapi"
	return result;
#line 216 "gitg-date.c"
}


static gboolean
gitg_date_fetch_and_set_double (GMatchInfo* info,
                                const gchar* name,
                                gdouble* retval)
{
	gboolean result = FALSE;
	gchar* val = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 152 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 152 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 154 "../libgitg/gitg-date.vala"
	_tmp0_ = g_match_info_fetch_named (info, name);
#line 154 "../libgitg/gitg-date.vala"
	val = _tmp0_;
#line 156 "../libgitg/gitg-date.vala"
	_tmp1_ = val;
#line 156 "../libgitg/gitg-date.vala"
	if (_tmp1_ == NULL) {
#line 158 "../libgitg/gitg-date.vala"
		result = FALSE;
#line 158 "../libgitg/gitg-date.vala"
		_g_free0 (val);
#line 158 "../libgitg/gitg-date.vala"
		return result;
#line 248 "gitg-date.c"
	}
#line 161 "../libgitg/gitg-date.vala"
	_tmp2_ = val;
#line 161 "../libgitg/gitg-date.vala"
	*retval = double_parse (_tmp2_);
#line 162 "../libgitg/gitg-date.vala"
	result = TRUE;
#line 162 "../libgitg/gitg-date.vala"
	_g_free0 (val);
#line 162 "../libgitg/gitg-date.vala"
	return result;
#line 260 "gitg-date.c"
}


static gint64
int64_parse (const gchar* str)
{
	gint64 result = 0LL;
	gint64 _tmp0_;
#line 722 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 723 "glib-2.0.vapi"
	_tmp0_ = g_ascii_strtoll (str, NULL, (guint) 0);
#line 723 "glib-2.0.vapi"
	result = _tmp0_;
#line 723 "glib-2.0.vapi"
	return result;
#line 277 "gitg-date.c"
}


static GDateTime*
gitg_date_parse_internal (GMatchInfo* info,
                          GError** error)
{
	GDateTime* result = NULL;
	gchar* timestamp = NULL;
	gchar* _tmp0_;
	gint64 unixt = 0LL;
	const gchar* _tmp1_;
	gchar* tzs = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
#line 165 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 167 "../libgitg/gitg-date.vala"
	_tmp0_ = g_match_info_fetch_named (info, "timestamp");
#line 167 "../libgitg/gitg-date.vala"
	timestamp = _tmp0_;
#line 168 "../libgitg/gitg-date.vala"
	_tmp1_ = timestamp;
#line 168 "../libgitg/gitg-date.vala"
	unixt = int64_parse (_tmp1_);
#line 170 "../libgitg/gitg-date.vala"
	_tmp2_ = g_match_info_fetch_named (info, "tz");
#line 170 "../libgitg/gitg-date.vala"
	tzs = _tmp2_;
#line 172 "../libgitg/gitg-date.vala"
	_tmp3_ = tzs;
#line 172 "../libgitg/gitg-date.vala"
	if (_tmp3_ != NULL) {
#line 311 "gitg-date.c"
		GDateTime* ret = NULL;
		gint64 _tmp4_;
		GDateTime* _tmp5_;
		GDateTime* _tmp6_;
		const gchar* _tmp7_;
		GTimeZone* _tmp8_;
		GTimeZone* _tmp9_;
		GDateTime* _tmp10_;
		GDateTime* _tmp11_;
#line 174 "../libgitg/gitg-date.vala"
		_tmp4_ = unixt;
#line 174 "../libgitg/gitg-date.vala"
		_tmp5_ = g_date_time_new_from_unix_utc (_tmp4_);
#line 174 "../libgitg/gitg-date.vala"
		ret = _tmp5_;
#line 175 "../libgitg/gitg-date.vala"
		_tmp6_ = ret;
#line 175 "../libgitg/gitg-date.vala"
		_tmp7_ = tzs;
#line 175 "../libgitg/gitg-date.vala"
		_tmp8_ = g_time_zone_new (_tmp7_);
#line 175 "../libgitg/gitg-date.vala"
		_tmp9_ = _tmp8_;
#line 175 "../libgitg/gitg-date.vala"
		_tmp10_ = g_date_time_to_timezone (_tmp6_, _tmp9_);
#line 175 "../libgitg/gitg-date.vala"
		_tmp11_ = _tmp10_;
#line 175 "../libgitg/gitg-date.vala"
		_g_time_zone_unref0 (_tmp9_);
#line 175 "../libgitg/gitg-date.vala"
		result = _tmp11_;
#line 175 "../libgitg/gitg-date.vala"
		_g_date_time_unref0 (ret);
#line 175 "../libgitg/gitg-date.vala"
		_g_free0 (tzs);
#line 175 "../libgitg/gitg-date.vala"
		_g_free0 (timestamp);
#line 175 "../libgitg/gitg-date.vala"
		return result;
#line 351 "gitg-date.c"
	} else {
		gint64 _tmp12_;
		GDateTime* _tmp13_;
#line 179 "../libgitg/gitg-date.vala"
		_tmp12_ = unixt;
#line 179 "../libgitg/gitg-date.vala"
		_tmp13_ = g_date_time_new_from_unix_local (_tmp12_);
#line 179 "../libgitg/gitg-date.vala"
		result = _tmp13_;
#line 179 "../libgitg/gitg-date.vala"
		_g_free0 (tzs);
#line 179 "../libgitg/gitg-date.vala"
		_g_free0 (timestamp);
#line 179 "../libgitg/gitg-date.vala"
		return result;
#line 367 "gitg-date.c"
	}
#line 165 "../libgitg/gitg-date.vala"
	_g_free0 (tzs);
#line 165 "../libgitg/gitg-date.vala"
	_g_free0 (timestamp);
#line 373 "gitg-date.c"
}


static GDateTime*
gitg_date_parse_iso8601 (GMatchInfo* info,
                         GError** error)
{
	GDateTime* result = NULL;
	GTimeZone* tz = NULL;
	GTimeZone* _tmp0_;
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gdouble seconds = 0.0;
	gchar* tzs = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GTimeZone* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gdouble _tmp12_;
	GDateTime* _tmp13_;
#line 183 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 185 "../libgitg/gitg-date.vala"
	_tmp0_ = g_time_zone_new_utc ();
#line 185 "../libgitg/gitg-date.vala"
	tz = _tmp0_;
#line 187 "../libgitg/gitg-date.vala"
	year = 0;
#line 188 "../libgitg/gitg-date.vala"
	month = 1;
#line 189 "../libgitg/gitg-date.vala"
	day = 1;
#line 190 "../libgitg/gitg-date.vala"
	hour = 0;
#line 191 "../libgitg/gitg-date.vala"
	minute = 0;
#line 192 "../libgitg/gitg-date.vala"
	seconds = 0.0;
#line 194 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "year", &year);
#line 195 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "month", &month);
#line 196 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "day", &day);
#line 197 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "hour", &hour);
#line 198 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "minute", &minute);
#line 199 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_double (info, "seconds", &seconds);
#line 201 "../libgitg/gitg-date.vala"
	_tmp1_ = g_match_info_fetch_named (info, "tz");
#line 201 "../libgitg/gitg-date.vala"
	tzs = _tmp1_;
#line 203 "../libgitg/gitg-date.vala"
	_tmp2_ = tzs;
#line 203 "../libgitg/gitg-date.vala"
	if (_tmp2_ != NULL) {
#line 439 "gitg-date.c"
		const gchar* _tmp3_;
		GTimeZone* _tmp4_;
#line 205 "../libgitg/gitg-date.vala"
		_tmp3_ = tzs;
#line 205 "../libgitg/gitg-date.vala"
		_tmp4_ = g_time_zone_new (_tmp3_);
#line 205 "../libgitg/gitg-date.vala"
		_g_time_zone_unref0 (tz);
#line 205 "../libgitg/gitg-date.vala"
		tz = _tmp4_;
#line 450 "gitg-date.c"
	} else {
		GTimeZone* _tmp5_;
#line 209 "../libgitg/gitg-date.vala"
		_tmp5_ = g_time_zone_new_local ();
#line 209 "../libgitg/gitg-date.vala"
		_g_time_zone_unref0 (tz);
#line 209 "../libgitg/gitg-date.vala"
		tz = _tmp5_;
#line 459 "gitg-date.c"
	}
#line 212 "../libgitg/gitg-date.vala"
	_tmp6_ = tz;
#line 212 "../libgitg/gitg-date.vala"
	_tmp7_ = year;
#line 212 "../libgitg/gitg-date.vala"
	_tmp8_ = month;
#line 212 "../libgitg/gitg-date.vala"
	_tmp9_ = day;
#line 212 "../libgitg/gitg-date.vala"
	_tmp10_ = hour;
#line 212 "../libgitg/gitg-date.vala"
	_tmp11_ = minute;
#line 212 "../libgitg/gitg-date.vala"
	_tmp12_ = seconds;
#line 212 "../libgitg/gitg-date.vala"
	_tmp13_ = g_date_time_new (_tmp6_, _tmp7_, _tmp8_, _tmp9_, _tmp10_, _tmp11_, _tmp12_);
#line 212 "../libgitg/gitg-date.vala"
	result = _tmp13_;
#line 212 "../libgitg/gitg-date.vala"
	_g_free0 (tzs);
#line 212 "../libgitg/gitg-date.vala"
	_g_time_zone_unref0 (tz);
#line 212 "../libgitg/gitg-date.vala"
	return result;
#line 485 "gitg-date.c"
}


static GDateTime*
gitg_date_parse_rfc2822 (GMatchInfo* info,
                         GError** error)
{
	GDateTime* result = NULL;
	GTimeZone* tz = NULL;
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gdouble seconds = 0.0;
	gchar* monthstr = NULL;
	gchar* _tmp0_;
	gint _tmp14_;
	gchar* tzs = NULL;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	GTimeZone* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gdouble _tmp27_;
	GDateTime* _tmp28_;
	GError * _inner_error_ = NULL;
#line 215 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 218 "../libgitg/gitg-date.vala"
	year = 0;
#line 219 "../libgitg/gitg-date.vala"
	month = 0;
#line 220 "../libgitg/gitg-date.vala"
	day = 1;
#line 221 "../libgitg/gitg-date.vala"
	hour = 0;
#line 222 "../libgitg/gitg-date.vala"
	minute = 0;
#line 223 "../libgitg/gitg-date.vala"
	seconds = (gdouble) 0;
#line 225 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "year", &year);
#line 227 "../libgitg/gitg-date.vala"
	_tmp0_ = g_match_info_fetch_named (info, "month");
#line 227 "../libgitg/gitg-date.vala"
	monthstr = _tmp0_;
#line 536 "gitg-date.c"
	{
		gint i = 0;
#line 229 "../libgitg/gitg-date.vala"
		i = 0;
#line 541 "gitg-date.c"
		{
			gboolean _tmp1_ = FALSE;
#line 229 "../libgitg/gitg-date.vala"
			_tmp1_ = TRUE;
#line 229 "../libgitg/gitg-date.vala"
			while (TRUE) {
#line 548 "gitg-date.c"
				gint _tmp3_;
				gchar** _tmp4_;
				gint _tmp4__length1;
				gboolean _tmp5_ = FALSE;
				gchar** _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				const gchar* _tmp8_;
#line 229 "../libgitg/gitg-date.vala"
				if (!_tmp1_) {
#line 559 "gitg-date.c"
					gint _tmp2_;
#line 229 "../libgitg/gitg-date.vala"
					_tmp2_ = i;
#line 229 "../libgitg/gitg-date.vala"
					i = _tmp2_ + 1;
#line 565 "gitg-date.c"
				}
#line 229 "../libgitg/gitg-date.vala"
				_tmp1_ = FALSE;
#line 229 "../libgitg/gitg-date.vala"
				_tmp3_ = i;
#line 229 "../libgitg/gitg-date.vala"
				_tmp4_ = gitg_date_s_months;
#line 229 "../libgitg/gitg-date.vala"
				_tmp4__length1 = gitg_date_s_months_length1;
#line 229 "../libgitg/gitg-date.vala"
				if (!(_tmp3_ < _tmp4__length1)) {
#line 229 "../libgitg/gitg-date.vala"
					break;
#line 579 "gitg-date.c"
				}
#line 231 "../libgitg/gitg-date.vala"
				_tmp6_ = gitg_date_s_months;
#line 231 "../libgitg/gitg-date.vala"
				_tmp6__length1 = gitg_date_s_months_length1;
#line 231 "../libgitg/gitg-date.vala"
				_tmp7_ = i;
#line 231 "../libgitg/gitg-date.vala"
				_tmp8_ = _tmp6_[_tmp7_];
#line 231 "../libgitg/gitg-date.vala"
				if (_tmp8_ != NULL) {
#line 591 "gitg-date.c"
					gchar** _tmp9_;
					gint _tmp9__length1;
					gint _tmp10_;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
#line 231 "../libgitg/gitg-date.vala"
					_tmp9_ = gitg_date_s_months;
#line 231 "../libgitg/gitg-date.vala"
					_tmp9__length1 = gitg_date_s_months_length1;
#line 231 "../libgitg/gitg-date.vala"
					_tmp10_ = i;
#line 231 "../libgitg/gitg-date.vala"
					_tmp11_ = _tmp9_[_tmp10_];
#line 231 "../libgitg/gitg-date.vala"
					_tmp12_ = monthstr;
#line 231 "../libgitg/gitg-date.vala"
					_tmp5_ = g_strcmp0 (_tmp11_, _tmp12_) == 0;
#line 609 "gitg-date.c"
				} else {
#line 231 "../libgitg/gitg-date.vala"
					_tmp5_ = FALSE;
#line 613 "gitg-date.c"
				}
#line 231 "../libgitg/gitg-date.vala"
				if (_tmp5_) {
#line 617 "gitg-date.c"
					gint _tmp13_;
#line 233 "../libgitg/gitg-date.vala"
					_tmp13_ = i;
#line 233 "../libgitg/gitg-date.vala"
					month = _tmp13_;
#line 234 "../libgitg/gitg-date.vala"
					break;
#line 625 "gitg-date.c"
				}
			}
		}
	}
#line 238 "../libgitg/gitg-date.vala"
	_tmp14_ = month;
#line 238 "../libgitg/gitg-date.vala"
	if (_tmp14_ == 0) {
#line 634 "gitg-date.c"
		GError* _tmp15_;
#line 240 "../libgitg/gitg-date.vala"
		_tmp15_ = g_error_new_literal (GITG_DATE_ERROR, GITG_DATE_ERROR_INVALID_FORMAT, "Invalid month specified");
#line 240 "../libgitg/gitg-date.vala"
		_inner_error_ = _tmp15_;
#line 240 "../libgitg/gitg-date.vala"
		g_propagate_error (error, _inner_error_);
#line 240 "../libgitg/gitg-date.vala"
		_g_free0 (monthstr);
#line 240 "../libgitg/gitg-date.vala"
		_g_time_zone_unref0 (tz);
#line 240 "../libgitg/gitg-date.vala"
		return NULL;
#line 648 "gitg-date.c"
	}
#line 243 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "day", &day);
#line 244 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "hour", &hour);
#line 245 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "minute", &minute);
#line 246 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_double (info, "seconds", &seconds);
#line 248 "../libgitg/gitg-date.vala"
	_tmp16_ = g_match_info_fetch_named (info, "tz");
#line 248 "../libgitg/gitg-date.vala"
	tzs = _tmp16_;
#line 250 "../libgitg/gitg-date.vala"
	_tmp17_ = tzs;
#line 250 "../libgitg/gitg-date.vala"
	if (_tmp17_ != NULL) {
#line 666 "gitg-date.c"
		const gchar* _tmp18_;
		GTimeZone* _tmp19_;
#line 252 "../libgitg/gitg-date.vala"
		_tmp18_ = tzs;
#line 252 "../libgitg/gitg-date.vala"
		_tmp19_ = g_time_zone_new (_tmp18_);
#line 252 "../libgitg/gitg-date.vala"
		_g_time_zone_unref0 (tz);
#line 252 "../libgitg/gitg-date.vala"
		tz = _tmp19_;
#line 677 "gitg-date.c"
	} else {
		GTimeZone* _tmp20_;
#line 256 "../libgitg/gitg-date.vala"
		_tmp20_ = g_time_zone_new_local ();
#line 256 "../libgitg/gitg-date.vala"
		_g_time_zone_unref0 (tz);
#line 256 "../libgitg/gitg-date.vala"
		tz = _tmp20_;
#line 686 "gitg-date.c"
	}
#line 259 "../libgitg/gitg-date.vala"
	_tmp21_ = tz;
#line 259 "../libgitg/gitg-date.vala"
	_tmp22_ = year;
#line 259 "../libgitg/gitg-date.vala"
	_tmp23_ = month;
#line 259 "../libgitg/gitg-date.vala"
	_tmp24_ = day;
#line 259 "../libgitg/gitg-date.vala"
	_tmp25_ = hour;
#line 259 "../libgitg/gitg-date.vala"
	_tmp26_ = minute;
#line 259 "../libgitg/gitg-date.vala"
	_tmp27_ = seconds;
#line 259 "../libgitg/gitg-date.vala"
	_tmp28_ = g_date_time_new (_tmp21_, _tmp22_, _tmp23_, _tmp24_, _tmp25_, _tmp26_, _tmp27_);
#line 259 "../libgitg/gitg-date.vala"
	result = _tmp28_;
#line 259 "../libgitg/gitg-date.vala"
	_g_free0 (tzs);
#line 259 "../libgitg/gitg-date.vala"
	_g_free0 (monthstr);
#line 259 "../libgitg/gitg-date.vala"
	_g_time_zone_unref0 (tz);
#line 259 "../libgitg/gitg-date.vala"
	return result;
#line 714 "gitg-date.c"
}


static gboolean
gitg_date_real_init (GInitable* base,
                     GCancellable* cancellable,
                     GError** error)
{
	GitgDate * self;
	gboolean result = FALSE;
	GMatchInfo* info = NULL;
	GRegex* _tmp0_;
	const gchar* _tmp1_;
	GMatchInfo* _tmp2_ = NULL;
	gboolean _tmp3_;
	GRegex* _tmp9_;
	const gchar* _tmp10_;
	GMatchInfo* _tmp11_ = NULL;
	gboolean _tmp12_;
	GRegex* _tmp18_;
	const gchar* _tmp19_;
	GMatchInfo* _tmp20_ = NULL;
	gboolean _tmp21_;
	GError* _tmp27_;
	gboolean _tmp28_ = FALSE;
	GError * _inner_error_ = NULL;
#line 274 "../libgitg/gitg-date.vala"
	self = (GitgDate*) base;
#line 278 "../libgitg/gitg-date.vala"
	_tmp0_ = gitg_date_s_internal;
#line 278 "../libgitg/gitg-date.vala"
	_tmp1_ = self->priv->_date_string;
#line 278 "../libgitg/gitg-date.vala"
	_tmp3_ = g_regex_match (_tmp0_, _tmp1_, 0, &_tmp2_);
#line 278 "../libgitg/gitg-date.vala"
	_g_match_info_unref0 (info);
#line 278 "../libgitg/gitg-date.vala"
	info = _tmp2_;
#line 278 "../libgitg/gitg-date.vala"
	if (_tmp3_) {
#line 755 "gitg-date.c"
		GDateTime* _tmp4_ = NULL;
		GMatchInfo* _tmp5_;
		GDateTime* _tmp6_;
		GDateTime* _tmp8_;
#line 280 "../libgitg/gitg-date.vala"
		_tmp5_ = info;
#line 280 "../libgitg/gitg-date.vala"
		_tmp6_ = gitg_date_parse_internal (_tmp5_, &_inner_error_);
#line 280 "../libgitg/gitg-date.vala"
		_tmp4_ = _tmp6_;
#line 280 "../libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 768 "gitg-date.c"
			gboolean _tmp7_ = FALSE;
#line 280 "../libgitg/gitg-date.vala"
			g_propagate_error (error, _inner_error_);
#line 280 "../libgitg/gitg-date.vala"
			_g_match_info_unref0 (info);
#line 280 "../libgitg/gitg-date.vala"
			return _tmp7_;
#line 776 "gitg-date.c"
		}
#line 280 "../libgitg/gitg-date.vala"
		_tmp8_ = _tmp4_;
#line 280 "../libgitg/gitg-date.vala"
		_tmp4_ = NULL;
#line 280 "../libgitg/gitg-date.vala"
		_g_date_time_unref0 (self->priv->d_datetime);
#line 280 "../libgitg/gitg-date.vala"
		self->priv->d_datetime = _tmp8_;
#line 282 "../libgitg/gitg-date.vala"
		result = TRUE;
#line 282 "../libgitg/gitg-date.vala"
		_g_date_time_unref0 (_tmp4_);
#line 282 "../libgitg/gitg-date.vala"
		_g_match_info_unref0 (info);
#line 282 "../libgitg/gitg-date.vala"
		return result;
#line 794 "gitg-date.c"
	}
#line 285 "../libgitg/gitg-date.vala"
	_tmp9_ = gitg_date_s_iso8601;
#line 285 "../libgitg/gitg-date.vala"
	_tmp10_ = self->priv->_date_string;
#line 285 "../libgitg/gitg-date.vala"
	_tmp12_ = g_regex_match (_tmp9_, _tmp10_, 0, &_tmp11_);
#line 285 "../libgitg/gitg-date.vala"
	_g_match_info_unref0 (info);
#line 285 "../libgitg/gitg-date.vala"
	info = _tmp11_;
#line 285 "../libgitg/gitg-date.vala"
	if (_tmp12_) {
#line 808 "gitg-date.c"
		GDateTime* _tmp13_ = NULL;
		GMatchInfo* _tmp14_;
		GDateTime* _tmp15_;
		GDateTime* _tmp17_;
#line 287 "../libgitg/gitg-date.vala"
		_tmp14_ = info;
#line 287 "../libgitg/gitg-date.vala"
		_tmp15_ = gitg_date_parse_iso8601 (_tmp14_, &_inner_error_);
#line 287 "../libgitg/gitg-date.vala"
		_tmp13_ = _tmp15_;
#line 287 "../libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 821 "gitg-date.c"
			gboolean _tmp16_ = FALSE;
#line 287 "../libgitg/gitg-date.vala"
			g_propagate_error (error, _inner_error_);
#line 287 "../libgitg/gitg-date.vala"
			_g_match_info_unref0 (info);
#line 287 "../libgitg/gitg-date.vala"
			return _tmp16_;
#line 829 "gitg-date.c"
		}
#line 287 "../libgitg/gitg-date.vala"
		_tmp17_ = _tmp13_;
#line 287 "../libgitg/gitg-date.vala"
		_tmp13_ = NULL;
#line 287 "../libgitg/gitg-date.vala"
		_g_date_time_unref0 (self->priv->d_datetime);
#line 287 "../libgitg/gitg-date.vala"
		self->priv->d_datetime = _tmp17_;
#line 289 "../libgitg/gitg-date.vala"
		result = TRUE;
#line 289 "../libgitg/gitg-date.vala"
		_g_date_time_unref0 (_tmp13_);
#line 289 "../libgitg/gitg-date.vala"
		_g_match_info_unref0 (info);
#line 289 "../libgitg/gitg-date.vala"
		return result;
#line 847 "gitg-date.c"
	}
#line 292 "../libgitg/gitg-date.vala"
	_tmp18_ = gitg_date_s_rfc2822;
#line 292 "../libgitg/gitg-date.vala"
	_tmp19_ = self->priv->_date_string;
#line 292 "../libgitg/gitg-date.vala"
	_tmp21_ = g_regex_match (_tmp18_, _tmp19_, 0, &_tmp20_);
#line 292 "../libgitg/gitg-date.vala"
	_g_match_info_unref0 (info);
#line 292 "../libgitg/gitg-date.vala"
	info = _tmp20_;
#line 292 "../libgitg/gitg-date.vala"
	if (_tmp21_) {
#line 861 "gitg-date.c"
		GDateTime* _tmp22_ = NULL;
		GMatchInfo* _tmp23_;
		GDateTime* _tmp24_;
		GDateTime* _tmp26_;
#line 294 "../libgitg/gitg-date.vala"
		_tmp23_ = info;
#line 294 "../libgitg/gitg-date.vala"
		_tmp24_ = gitg_date_parse_rfc2822 (_tmp23_, &_inner_error_);
#line 294 "../libgitg/gitg-date.vala"
		_tmp22_ = _tmp24_;
#line 294 "../libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 874 "gitg-date.c"
			gboolean _tmp25_ = FALSE;
#line 294 "../libgitg/gitg-date.vala"
			g_propagate_error (error, _inner_error_);
#line 294 "../libgitg/gitg-date.vala"
			_g_match_info_unref0 (info);
#line 294 "../libgitg/gitg-date.vala"
			return _tmp25_;
#line 882 "gitg-date.c"
		}
#line 294 "../libgitg/gitg-date.vala"
		_tmp26_ = _tmp22_;
#line 294 "../libgitg/gitg-date.vala"
		_tmp22_ = NULL;
#line 294 "../libgitg/gitg-date.vala"
		_g_date_time_unref0 (self->priv->d_datetime);
#line 294 "../libgitg/gitg-date.vala"
		self->priv->d_datetime = _tmp26_;
#line 296 "../libgitg/gitg-date.vala"
		result = TRUE;
#line 296 "../libgitg/gitg-date.vala"
		_g_date_time_unref0 (_tmp22_);
#line 296 "../libgitg/gitg-date.vala"
		_g_match_info_unref0 (info);
#line 296 "../libgitg/gitg-date.vala"
		return result;
#line 900 "gitg-date.c"
	}
#line 299 "../libgitg/gitg-date.vala"
	_tmp27_ = g_error_new_literal (GITG_DATE_ERROR, GITG_DATE_ERROR_INVALID_FORMAT, "Invalid date format");
#line 299 "../libgitg/gitg-date.vala"
	_inner_error_ = _tmp27_;
#line 299 "../libgitg/gitg-date.vala"
	g_propagate_error (error, _inner_error_);
#line 299 "../libgitg/gitg-date.vala"
	_g_match_info_unref0 (info);
#line 299 "../libgitg/gitg-date.vala"
	return _tmp28_;
#line 912 "gitg-date.c"
}


GitgDate*
gitg_date_construct (GType object_type,
                     const gchar* date,
                     GError** error)
{
	GitgDate * self = NULL;
	GError * _inner_error_ = NULL;
#line 302 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 304 "../libgitg/gitg-date.vala"
	self = (GitgDate*) g_object_new (object_type, "date-string", date, NULL);
#line 305 "../libgitg/gitg-date.vala"
	g_initable_init (G_TYPE_CHECK_INSTANCE_CAST (self, g_initable_get_type (), GInitable), NULL, &_inner_error_);
#line 305 "../libgitg/gitg-date.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 305 "../libgitg/gitg-date.vala"
		g_propagate_error (error, _inner_error_);
#line 305 "../libgitg/gitg-date.vala"
		_g_object_unref0 (self);
#line 305 "../libgitg/gitg-date.vala"
		return NULL;
#line 937 "gitg-date.c"
	}
#line 302 "../libgitg/gitg-date.vala"
	return self;
#line 941 "gitg-date.c"
}


GitgDate*
gitg_date_new (const gchar* date,
               GError** error)
{
#line 302 "../libgitg/gitg-date.vala"
	return gitg_date_construct (GITG_TYPE_DATE, date, error);
#line 951 "gitg-date.c"
}


static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 337 "../libgitg/gitg-date.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 960 "gitg-date.c"
}


gchar*
gitg_date_for_display (GitgDate* self)
{
	gchar* result = NULL;
	GDateTime* dt = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GTimeSpan t = 0LL;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GTimeSpan _tmp5_;
	GTimeSpan _tmp6_;
#line 335 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 337 "../libgitg/gitg-date.vala"
	_tmp0_ = self->priv->d_datetime;
#line 337 "../libgitg/gitg-date.vala"
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
#line 337 "../libgitg/gitg-date.vala"
	dt = _tmp1_;
#line 338 "../libgitg/gitg-date.vala"
	_tmp2_ = g_date_time_new_now_local ();
#line 338 "../libgitg/gitg-date.vala"
	_tmp3_ = _tmp2_;
#line 338 "../libgitg/gitg-date.vala"
	_tmp4_ = dt;
#line 338 "../libgitg/gitg-date.vala"
	_tmp5_ = g_date_time_difference (_tmp3_, _tmp4_);
#line 338 "../libgitg/gitg-date.vala"
	_g_date_time_unref0 (_tmp3_);
#line 338 "../libgitg/gitg-date.vala"
	t = _tmp5_;
#line 340 "../libgitg/gitg-date.vala"
	_tmp6_ = t;
#line 340 "../libgitg/gitg-date.vala"
	if (((gdouble) _tmp6_) < (G_TIME_SPAN_MINUTE * 29.5)) {
#line 1001 "gitg-date.c"
		gint rounded_minutes = 0;
		GTimeSpan _tmp7_;
		gint _tmp8_;
#line 342 "../libgitg/gitg-date.vala"
		_tmp7_ = t;
#line 342 "../libgitg/gitg-date.vala"
		rounded_minutes = (gint) round ((gdouble) (((gfloat) _tmp7_) / G_TIME_SPAN_MINUTE));
#line 344 "../libgitg/gitg-date.vala"
		_tmp8_ = rounded_minutes;
#line 344 "../libgitg/gitg-date.vala"
		if (_tmp8_ == 0) {
#line 1013 "gitg-date.c"
			gchar* _tmp9_;
#line 346 "../libgitg/gitg-date.vala"
			_tmp9_ = g_strdup (_ ("Now"));
#line 346 "../libgitg/gitg-date.vala"
			result = _tmp9_;
#line 346 "../libgitg/gitg-date.vala"
			_g_date_time_unref0 (dt);
#line 346 "../libgitg/gitg-date.vala"
			return result;
#line 1023 "gitg-date.c"
		} else {
			gint _tmp10_;
			gint _tmp11_;
			gchar* _tmp12_;
#line 350 "../libgitg/gitg-date.vala"
			_tmp10_ = rounded_minutes;
#line 350 "../libgitg/gitg-date.vala"
			_tmp11_ = rounded_minutes;
#line 350 "../libgitg/gitg-date.vala"
			_tmp12_ = g_strdup_printf (ngettext ("A minute ago", "%d minutes ago", (gulong) _tmp10_), _tmp11_);
#line 350 "../libgitg/gitg-date.vala"
			result = _tmp12_;
#line 350 "../libgitg/gitg-date.vala"
			_g_date_time_unref0 (dt);
#line 350 "../libgitg/gitg-date.vala"
			return result;
#line 1040 "gitg-date.c"
		}
	} else {
		GTimeSpan _tmp13_;
#line 353 "../libgitg/gitg-date.vala"
		_tmp13_ = t;
#line 353 "../libgitg/gitg-date.vala"
		if (_tmp13_ < (G_TIME_SPAN_MINUTE * 45)) {
#line 1048 "gitg-date.c"
			gchar* _tmp14_;
#line 355 "../libgitg/gitg-date.vala"
			_tmp14_ = g_strdup (_ ("Half an hour ago"));
#line 355 "../libgitg/gitg-date.vala"
			result = _tmp14_;
#line 355 "../libgitg/gitg-date.vala"
			_g_date_time_unref0 (dt);
#line 355 "../libgitg/gitg-date.vala"
			return result;
#line 1058 "gitg-date.c"
		} else {
			GTimeSpan _tmp15_;
#line 357 "../libgitg/gitg-date.vala"
			_tmp15_ = t;
#line 357 "../libgitg/gitg-date.vala"
			if (((gdouble) _tmp15_) < (G_TIME_SPAN_HOUR * 23.5)) {
#line 1065 "gitg-date.c"
				gint rounded_hours = 0;
				GTimeSpan _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gchar* _tmp19_;
#line 359 "../libgitg/gitg-date.vala"
				_tmp16_ = t;
#line 359 "../libgitg/gitg-date.vala"
				rounded_hours = (gint) round ((gdouble) (((gfloat) _tmp16_) / G_TIME_SPAN_HOUR));
#line 360 "../libgitg/gitg-date.vala"
				_tmp17_ = rounded_hours;
#line 360 "../libgitg/gitg-date.vala"
				_tmp18_ = rounded_hours;
#line 360 "../libgitg/gitg-date.vala"
				_tmp19_ = g_strdup_printf (ngettext ("An hour ago", "%d hours ago", (gulong) _tmp17_), _tmp18_);
#line 360 "../libgitg/gitg-date.vala"
				result = _tmp19_;
#line 360 "../libgitg/gitg-date.vala"
				_g_date_time_unref0 (dt);
#line 360 "../libgitg/gitg-date.vala"
				return result;
#line 1087 "gitg-date.c"
			} else {
				GTimeSpan _tmp20_;
#line 362 "../libgitg/gitg-date.vala"
				_tmp20_ = t;
#line 362 "../libgitg/gitg-date.vala"
				if (_tmp20_ < (G_TIME_SPAN_DAY * 7)) {
#line 1094 "gitg-date.c"
					gint rounded_days = 0;
					GTimeSpan _tmp21_;
					gint _tmp22_;
					gint _tmp23_;
					gchar* _tmp24_;
#line 364 "../libgitg/gitg-date.vala"
					_tmp21_ = t;
#line 364 "../libgitg/gitg-date.vala"
					rounded_days = (gint) round ((gdouble) (((gfloat) _tmp21_) / G_TIME_SPAN_DAY));
#line 365 "../libgitg/gitg-date.vala"
					_tmp22_ = rounded_days;
#line 365 "../libgitg/gitg-date.vala"
					_tmp23_ = rounded_days;
#line 365 "../libgitg/gitg-date.vala"
					_tmp24_ = g_strdup_printf (ngettext ("A day ago", "%d days ago", (gulong) _tmp22_), _tmp23_);
#line 365 "../libgitg/gitg-date.vala"
					result = _tmp24_;
#line 365 "../libgitg/gitg-date.vala"
					_g_date_time_unref0 (dt);
#line 365 "../libgitg/gitg-date.vala"
					return result;
#line 1116 "gitg-date.c"
				} else {
					GDateTime* _tmp25_;
					GDateTime* _tmp26_;
					GDateTime* _tmp27_;
					gboolean _tmp28_;
#line 367 "../libgitg/gitg-date.vala"
					_tmp25_ = dt;
#line 367 "../libgitg/gitg-date.vala"
					_tmp26_ = g_date_time_new_now_local ();
#line 367 "../libgitg/gitg-date.vala"
					_tmp27_ = _tmp26_;
#line 367 "../libgitg/gitg-date.vala"
					_tmp28_ = g_date_time_get_year (_tmp25_) == g_date_time_get_year (_tmp27_);
#line 367 "../libgitg/gitg-date.vala"
					_g_date_time_unref0 (_tmp27_);
#line 367 "../libgitg/gitg-date.vala"
					if (_tmp28_) {
#line 1134 "gitg-date.c"
						gboolean _tmp29_;
						gboolean _tmp30_;
#line 369 "../libgitg/gitg-date.vala"
						_tmp29_ = gitg_date_get_is_24h (self);
#line 369 "../libgitg/gitg-date.vala"
						_tmp30_ = _tmp29_;
#line 369 "../libgitg/gitg-date.vala"
						if (_tmp30_) {
#line 1143 "gitg-date.c"
							GDateTime* _tmp31_;
							gchar* _tmp32_;
#line 374 "../libgitg/gitg-date.vala"
							_tmp31_ = dt;
#line 374 "../libgitg/gitg-date.vala"
							_tmp32_ = g_date_time_format (_tmp31_, _ ("%b %e, %H:%M"));
#line 374 "../libgitg/gitg-date.vala"
							result = _tmp32_;
#line 374 "../libgitg/gitg-date.vala"
							_g_date_time_unref0 (dt);
#line 374 "../libgitg/gitg-date.vala"
							return result;
#line 1156 "gitg-date.c"
						} else {
							GDateTime* _tmp33_;
							gchar* _tmp34_;
#line 381 "../libgitg/gitg-date.vala"
							_tmp33_ = dt;
#line 381 "../libgitg/gitg-date.vala"
							_tmp34_ = g_date_time_format (_tmp33_, _ ("%b %e, %I:%M %p"));
#line 381 "../libgitg/gitg-date.vala"
							result = _tmp34_;
#line 381 "../libgitg/gitg-date.vala"
							_g_date_time_unref0 (dt);
#line 381 "../libgitg/gitg-date.vala"
							return result;
#line 1170 "gitg-date.c"
						}
					} else {
						gboolean _tmp35_;
						gboolean _tmp36_;
#line 386 "../libgitg/gitg-date.vala"
						_tmp35_ = gitg_date_get_is_24h (self);
#line 386 "../libgitg/gitg-date.vala"
						_tmp36_ = _tmp35_;
#line 386 "../libgitg/gitg-date.vala"
						if (_tmp36_) {
#line 1181 "gitg-date.c"
							GDateTime* _tmp37_;
							gchar* _tmp38_;
#line 391 "../libgitg/gitg-date.vala"
							_tmp37_ = dt;
#line 391 "../libgitg/gitg-date.vala"
							_tmp38_ = g_date_time_format (_tmp37_, _ ("%b %e %Y, %H:%M"));
#line 391 "../libgitg/gitg-date.vala"
							result = _tmp38_;
#line 391 "../libgitg/gitg-date.vala"
							_g_date_time_unref0 (dt);
#line 391 "../libgitg/gitg-date.vala"
							return result;
#line 1194 "gitg-date.c"
						} else {
							GDateTime* _tmp39_;
							gchar* _tmp40_;
#line 398 "../libgitg/gitg-date.vala"
							_tmp39_ = dt;
#line 398 "../libgitg/gitg-date.vala"
							_tmp40_ = g_date_time_format (_tmp39_, _ ("%b %e %Y, %I:%M %p"));
#line 398 "../libgitg/gitg-date.vala"
							result = _tmp40_;
#line 398 "../libgitg/gitg-date.vala"
							_g_date_time_unref0 (dt);
#line 398 "../libgitg/gitg-date.vala"
							return result;
#line 1208 "gitg-date.c"
						}
					}
				}
			}
		}
	}
#line 335 "../libgitg/gitg-date.vala"
	_g_date_time_unref0 (dt);
#line 1217 "gitg-date.c"
}


GitgDate*
gitg_date_construct_for_date_time (GType object_type,
                                   GDateTime* dt)
{
	GitgDate * self = NULL;
	GDateTime* _tmp0_;
#line 403 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (dt != NULL, NULL);
#line 403 "../libgitg/gitg-date.vala"
	self = (GitgDate*) g_object_new (object_type, NULL);
#line 405 "../libgitg/gitg-date.vala"
	_tmp0_ = _g_date_time_ref0 (dt);
#line 405 "../libgitg/gitg-date.vala"
	_g_date_time_unref0 (self->priv->d_datetime);
#line 405 "../libgitg/gitg-date.vala"
	self->priv->d_datetime = _tmp0_;
#line 403 "../libgitg/gitg-date.vala"
	return self;
#line 1239 "gitg-date.c"
}


GitgDate*
gitg_date_new_for_date_time (GDateTime* dt)
{
#line 403 "../libgitg/gitg-date.vala"
	return gitg_date_construct_for_date_time (GITG_TYPE_DATE, dt);
#line 1248 "gitg-date.c"
}


GDateTime*
gitg_date_parse (const gchar* date,
                 GError** error)
{
	GDateTime* result = NULL;
	GitgDate* _tmp0_ = NULL;
	GitgDate* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GError * _inner_error_ = NULL;
#line 408 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 410 "../libgitg/gitg-date.vala"
	_tmp1_ = gitg_date_new (date, &_inner_error_);
#line 410 "../libgitg/gitg-date.vala"
	_tmp0_ = _tmp1_;
#line 410 "../libgitg/gitg-date.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 410 "../libgitg/gitg-date.vala"
		g_propagate_error (error, _inner_error_);
#line 410 "../libgitg/gitg-date.vala"
		return NULL;
#line 1275 "gitg-date.c"
	}
#line 410 "../libgitg/gitg-date.vala"
	_tmp2_ = gitg_date_get_date (_tmp0_);
#line 410 "../libgitg/gitg-date.vala"
	_tmp3_ = _tmp2_;
#line 410 "../libgitg/gitg-date.vala"
	_tmp4_ = _g_date_time_ref0 (_tmp3_);
#line 410 "../libgitg/gitg-date.vala"
	result = _tmp4_;
#line 410 "../libgitg/gitg-date.vala"
	_g_object_unref0 (_tmp0_);
#line 410 "../libgitg/gitg-date.vala"
	return result;
#line 1289 "gitg-date.c"
}


const gchar*
gitg_date_get_date_string (GitgDate* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 266 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 266 "../libgitg/gitg-date.vala"
	_tmp0_ = self->priv->_date_string;
#line 266 "../libgitg/gitg-date.vala"
	result = _tmp0_;
#line 266 "../libgitg/gitg-date.vala"
	return result;
#line 1306 "gitg-date.c"
}


void
gitg_date_set_date_string (GitgDate* self,
                           const gchar* value)
{
#line 266 "../libgitg/gitg-date.vala"
	g_return_if_fail (self != NULL);
#line 266 "../libgitg/gitg-date.vala"
	if (g_strcmp0 (value, gitg_date_get_date_string (self)) != 0) {
#line 1318 "gitg-date.c"
		gchar* _tmp0_;
#line 266 "../libgitg/gitg-date.vala"
		_tmp0_ = g_strdup (value);
#line 266 "../libgitg/gitg-date.vala"
		_g_free0 (self->priv->_date_string);
#line 266 "../libgitg/gitg-date.vala"
		self->priv->_date_string = _tmp0_;
#line 266 "../libgitg/gitg-date.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_date_properties[GITG_DATE_DATE_STRING_PROPERTY]);
#line 1328 "gitg-date.c"
	}
}


GDateTime*
gitg_date_get_date (GitgDate* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 271 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 271 "../libgitg/gitg-date.vala"
	_tmp0_ = self->priv->d_datetime;
#line 271 "../libgitg/gitg-date.vala"
	result = _tmp0_;
#line 271 "../libgitg/gitg-date.vala"
	return result;
#line 1346 "gitg-date.c"
}


static gpointer
_g_settings_schema_source_ref0 (gpointer self)
{
#line 314 "../libgitg/gitg-date.vala"
	return self ? g_settings_schema_source_ref (self) : NULL;
#line 1355 "gitg-date.c"
}


static gboolean
gitg_date_get_is_24h (GitgDate* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	GSettings* _tmp1_;
	GSettings* _tmp14_;
	GSettings* _tmp15_;
#line 310 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 312 "../libgitg/gitg-date.vala"
	_tmp1_ = gitg_date_s_gnome_interface_settings;
#line 312 "../libgitg/gitg-date.vala"
	if (_tmp1_ == NULL) {
#line 1373 "gitg-date.c"
		gboolean _tmp2_;
#line 312 "../libgitg/gitg-date.vala"
		_tmp2_ = gitg_date_s_tried_gnome_interface_settings;
#line 312 "../libgitg/gitg-date.vala"
		_tmp0_ = !_tmp2_;
#line 1379 "gitg-date.c"
	} else {
#line 312 "../libgitg/gitg-date.vala"
		_tmp0_ = FALSE;
#line 1383 "gitg-date.c"
	}
#line 312 "../libgitg/gitg-date.vala"
	if (_tmp0_) {
#line 1387 "gitg-date.c"
		GSettingsSchemaSource* source = NULL;
		GSettingsSchemaSource* _tmp3_;
		GSettingsSchemaSource* _tmp4_;
		gchar* schema_id = NULL;
		gchar* _tmp5_;
		gboolean _tmp6_ = FALSE;
		GSettingsSchemaSource* _tmp7_;
#line 314 "../libgitg/gitg-date.vala"
		_tmp3_ = g_settings_schema_source_get_default ();
#line 314 "../libgitg/gitg-date.vala"
		_tmp4_ = _g_settings_schema_source_ref0 (_tmp3_);
#line 314 "../libgitg/gitg-date.vala"
		source = _tmp4_;
#line 316 "../libgitg/gitg-date.vala"
		gitg_date_s_tried_gnome_interface_settings = TRUE;
#line 318 "../libgitg/gitg-date.vala"
		_tmp5_ = g_strdup ("org.gnome.desktop.interface");
#line 318 "../libgitg/gitg-date.vala"
		schema_id = _tmp5_;
#line 320 "../libgitg/gitg-date.vala"
		_tmp7_ = source;
#line 320 "../libgitg/gitg-date.vala"
		if (_tmp7_ != NULL) {
#line 1411 "gitg-date.c"
			GSettingsSchemaSource* _tmp8_;
			const gchar* _tmp9_;
			GSettingsSchema* _tmp10_;
			GSettingsSchema* _tmp11_;
#line 320 "../libgitg/gitg-date.vala"
			_tmp8_ = source;
#line 320 "../libgitg/gitg-date.vala"
			_tmp9_ = schema_id;
#line 320 "../libgitg/gitg-date.vala"
			_tmp10_ = g_settings_schema_source_lookup (_tmp8_, _tmp9_, TRUE);
#line 320 "../libgitg/gitg-date.vala"
			_tmp11_ = _tmp10_;
#line 320 "../libgitg/gitg-date.vala"
			_tmp6_ = _tmp11_ != NULL;
#line 320 "../libgitg/gitg-date.vala"
			_g_settings_schema_unref0 (_tmp11_);
#line 1428 "gitg-date.c"
		} else {
#line 320 "../libgitg/gitg-date.vala"
			_tmp6_ = FALSE;
#line 1432 "gitg-date.c"
		}
#line 320 "../libgitg/gitg-date.vala"
		if (_tmp6_) {
#line 1436 "gitg-date.c"
			const gchar* _tmp12_;
			GSettings* _tmp13_;
#line 322 "../libgitg/gitg-date.vala"
			_tmp12_ = schema_id;
#line 322 "../libgitg/gitg-date.vala"
			_tmp13_ = g_settings_new (_tmp12_);
#line 322 "../libgitg/gitg-date.vala"
			_g_object_unref0 (gitg_date_s_gnome_interface_settings);
#line 322 "../libgitg/gitg-date.vala"
			gitg_date_s_gnome_interface_settings = _tmp13_;
#line 1447 "gitg-date.c"
		}
#line 312 "../libgitg/gitg-date.vala"
		_g_free0 (schema_id);
#line 312 "../libgitg/gitg-date.vala"
		_g_settings_schema_source_unref0 (source);
#line 1453 "gitg-date.c"
	}
#line 326 "../libgitg/gitg-date.vala"
	_tmp14_ = gitg_date_s_gnome_interface_settings;
#line 326 "../libgitg/gitg-date.vala"
	if (_tmp14_ == NULL) {
#line 328 "../libgitg/gitg-date.vala"
		result = FALSE;
#line 328 "../libgitg/gitg-date.vala"
		return result;
#line 1463 "gitg-date.c"
	}
#line 331 "../libgitg/gitg-date.vala"
	_tmp15_ = gitg_date_s_gnome_interface_settings;
#line 331 "../libgitg/gitg-date.vala"
	result = g_settings_get_enum (_tmp15_, "clock-format") == ((gint) G_DESKTOP_CLOCK_FORMAT_24H);
#line 331 "../libgitg/gitg-date.vala"
	return result;
#line 1471 "gitg-date.c"
}


static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1513 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	result = self;
#line 1514 "glib-2.0.vapi"
	return result;
#line 1485 "gitg-date.c"
}


static void
gitg_date_class_init (GitgDateClass * klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	GError * _inner_error_ = NULL;
#line 28 "../libgitg/gitg-date.vala"
	gitg_date_parent_class = g_type_class_peek_parent (klass);
#line 28 "../libgitg/gitg-date.vala"
	g_type_class_adjust_private_offset (klass, &GitgDate_private_offset);
#line 28 "../libgitg/gitg-date.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gitg_date_get_property;
#line 28 "../libgitg/gitg-date.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gitg_date_set_property;
#line 28 "../libgitg/gitg-date.vala"
	G_OBJECT_CLASS (klass)->finalize = gitg_date_finalize;
#line 28 "../libgitg/gitg-date.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_DATE_DATE_STRING_PROPERTY, gitg_date_properties[GITG_DATE_DATE_STRING_PROPERTY] = g_param_spec_string ("date-string", "date-string", "date-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "../libgitg/gitg-date.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_DATE_DATE_PROPERTY, gitg_date_properties[GITG_DATE_DATE_PROPERTY] = g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 37 "../libgitg/gitg-date.vala"
	_tmp0_ = g_strdup ("Jan");
#line 37 "../libgitg/gitg-date.vala"
	_tmp1_ = g_strdup ("Feb");
#line 37 "../libgitg/gitg-date.vala"
	_tmp2_ = g_strdup ("Mar");
#line 37 "../libgitg/gitg-date.vala"
	_tmp3_ = g_strdup ("Apr");
#line 37 "../libgitg/gitg-date.vala"
	_tmp4_ = g_strdup ("May");
#line 37 "../libgitg/gitg-date.vala"
	_tmp5_ = g_strdup ("Jun");
#line 37 "../libgitg/gitg-date.vala"
	_tmp6_ = g_strdup ("Jul");
#line 37 "../libgitg/gitg-date.vala"
	_tmp7_ = g_strdup ("Aug");
#line 37 "../libgitg/gitg-date.vala"
	_tmp8_ = g_strdup ("Sep");
#line 37 "../libgitg/gitg-date.vala"
	_tmp9_ = g_strdup ("Oct");
#line 37 "../libgitg/gitg-date.vala"
	_tmp10_ = g_strdup ("Nov");
#line 37 "../libgitg/gitg-date.vala"
	_tmp11_ = g_strdup ("Dec");
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_ = g_new0 (gchar*, 13 + 1);
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[0] = NULL;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[1] = _tmp0_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[2] = _tmp1_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[3] = _tmp2_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[4] = _tmp3_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[5] = _tmp4_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[6] = _tmp5_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[7] = _tmp6_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[8] = _tmp7_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[9] = _tmp8_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[10] = _tmp9_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[11] = _tmp10_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[12] = _tmp11_;
#line 37 "../libgitg/gitg-date.vala"
	gitg_date_s_months = _tmp12_;
#line 37 "../libgitg/gitg-date.vala"
	gitg_date_s_months_length1 = 13;
#line 1576 "gitg-date.c"
	{
		GRegex* _tmp13_ = NULL;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GRegex* _tmp16_;
		GRegex* _tmp17_;
		GRegex* _tmp18_;
		GRegex* _tmp19_ = NULL;
		gchar* _tmp20_;
		gchar* _tmp21_;
		GRegex* _tmp22_;
		GRegex* _tmp23_;
		GRegex* _tmp24_;
		GRegex* _tmp25_ = NULL;
		gchar* _tmp26_;
		gchar* _tmp27_;
		GRegex* _tmp28_;
		GRegex* _tmp29_;
		GRegex* _tmp30_;
#line 58 "../libgitg/gitg-date.vala"
		_tmp14_ = g_strconcat ("^\n" \
"			(?<year>[0-9]{4})\n" \
"			(?:\n" \
"				[-.]?(?:\n" \
"					(?<month>[0-9]{2})\n" \
"					(?:\n" \
"						[-.]?(?<day>[0-9]{2})\n" \
"					)?\n" \
"				|\n" \
"					W(?<week>[0-9]{2})\n" \
"					(?:\n" \
"						[-.]?(?<weekday>[0-9])\n" \
"					)?\n" \
"				)\n" \
"				(?:\n" \
"					[T ](?<hour>[0-9]{2})\n" \
"					(?:\n" \
"						:?\n" \
"						(?<minute>[0-9]{2})\n" \
"						(?:\n" \
"							:?\n" \
"							(?<seconds>[0-9]{2})\n" \
"							(?<tz>\n" \
"								(?<tzutc>Z) |\n" \
"								[+-](?<tzhour>[0-9]{2})\n" \
"								(?:\n" \
"									:?\n" \
"									(?<tzminute>[0-9]{2})\n" \
"								)?\n" \
"							)?\n" \
"						)?\n" \
"					)?\n" \
"				)?\n" \
"			)?\n" \
"		", "$", NULL);
#line 58 "../libgitg/gitg-date.vala"
		_tmp15_ = _tmp14_;
#line 58 "../libgitg/gitg-date.vala"
		_tmp16_ = g_regex_new (_tmp15_, G_REGEX_EXTENDED, 0, &_inner_error_);
#line 58 "../libgitg/gitg-date.vala"
		_tmp17_ = _tmp16_;
#line 58 "../libgitg/gitg-date.vala"
		_g_free0 (_tmp15_);
#line 58 "../libgitg/gitg-date.vala"
		_tmp13_ = _tmp17_;
#line 58 "../libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1610 "gitg-date.c"
			goto __catch32_g_error;
		}
#line 58 "../libgitg/gitg-date.vala"
		_tmp18_ = _tmp13_;
#line 58 "../libgitg/gitg-date.vala"
		_tmp13_ = NULL;
#line 58 "../libgitg/gitg-date.vala"
		_g_regex_unref0 (gitg_date_s_iso8601);
#line 58 "../libgitg/gitg-date.vala"
		gitg_date_s_iso8601 = _tmp18_;
#line 94 "../libgitg/gitg-date.vala"
		_tmp20_ = g_strconcat ("^\n" \
"			(?:\n" \
"				[\\s]*(?<dayofweek>Mon|Tue|Wed|Thu|Fri|Sat|Sun)\n" \
"				,\n" \
"			)?\n" \
"			[\\s]*(?<day>[0-9]{1,2})\n" \
"			[\\s]+\n" \
"				(?<month>Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\n" \
"			[\\s]+\n" \
"				(?<year>[0-9]{4})\n" \
"			[\\s]+\n" \
"				(?<hour>[0-9]{2})\n" \
"				:\n" \
"				(?<minute>[0-9]{2})\n" \
"				(?:\n" \
"					:\n" \
"					(?<seconds>[0-9]{2})\n" \
"				)?\n" \
"			[\\s]+\n" \
"			(?<tz>\n" \
"				[+-]\n" \
"				(?<tzhour>[0-9]{2})\n" \
"				(?<tzminute>[0-9]{2})\n" \
"			)\n" \
"		", "$", NULL);
#line 94 "../libgitg/gitg-date.vala"
		_tmp21_ = _tmp20_;
#line 94 "../libgitg/gitg-date.vala"
		_tmp22_ = g_regex_new (_tmp21_, G_REGEX_EXTENDED, 0, &_inner_error_);
#line 94 "../libgitg/gitg-date.vala"
		_tmp23_ = _tmp22_;
#line 94 "../libgitg/gitg-date.vala"
		_g_free0 (_tmp21_);
#line 94 "../libgitg/gitg-date.vala"
		_tmp19_ = _tmp23_;
#line 94 "../libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 94 "../libgitg/gitg-date.vala"
			_g_regex_unref0 (_tmp13_);
#line 1637 "gitg-date.c"
			goto __catch32_g_error;
		}
#line 94 "../libgitg/gitg-date.vala"
		_tmp24_ = _tmp19_;
#line 94 "../libgitg/gitg-date.vala"
		_tmp19_ = NULL;
#line 94 "../libgitg/gitg-date.vala"
		_g_regex_unref0 (gitg_date_s_rfc2822);
#line 94 "../libgitg/gitg-date.vala"
		gitg_date_s_rfc2822 = _tmp24_;
#line 120 "../libgitg/gitg-date.vala"
		_tmp26_ = g_strconcat ("^\n" \
"			@?\n" \
"			(?<timestamp>[0-9]+)\n" \
"			[ ](?<tz>\n" \
"				[+-](?<tzhour>[0-9]{2})\n" \
"				(?:\n" \
"					:?\n" \
"					(?<tzminute>[0-9]{2})?\n" \
"				)\n" \
"			)\n" \
"		", "$", NULL);
#line 120 "../libgitg/gitg-date.vala"
		_tmp27_ = _tmp26_;
#line 120 "../libgitg/gitg-date.vala"
		_tmp28_ = g_regex_new (_tmp27_, G_REGEX_EXTENDED, 0, &_inner_error_);
#line 120 "../libgitg/gitg-date.vala"
		_tmp29_ = _tmp28_;
#line 120 "../libgitg/gitg-date.vala"
		_g_free0 (_tmp27_);
#line 120 "../libgitg/gitg-date.vala"
		_tmp25_ = _tmp29_;
#line 120 "../libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 120 "../libgitg/gitg-date.vala"
			_g_regex_unref0 (_tmp19_);
#line 120 "../libgitg/gitg-date.vala"
			_g_regex_unref0 (_tmp13_);
#line 1666 "gitg-date.c"
			goto __catch32_g_error;
		}
#line 120 "../libgitg/gitg-date.vala"
		_tmp30_ = _tmp25_;
#line 120 "../libgitg/gitg-date.vala"
		_tmp25_ = NULL;
#line 120 "../libgitg/gitg-date.vala"
		_g_regex_unref0 (gitg_date_s_internal);
#line 120 "../libgitg/gitg-date.vala"
		gitg_date_s_internal = _tmp30_;
#line 55 "../libgitg/gitg-date.vala"
		_g_regex_unref0 (_tmp25_);
#line 55 "../libgitg/gitg-date.vala"
		_g_regex_unref0 (_tmp19_);
#line 55 "../libgitg/gitg-date.vala"
		_g_regex_unref0 (_tmp13_);
#line 1683 "gitg-date.c"
	}
	goto __finally32;
	__catch32_g_error:
	{
		GError* e = NULL;
		GError* _tmp31_;
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
#line 55 "../libgitg/gitg-date.vala"
		e = _inner_error_;
#line 55 "../libgitg/gitg-date.vala"
		_inner_error_ = NULL;
#line 135 "../libgitg/gitg-date.vala"
		_tmp31_ = e;
#line 135 "../libgitg/gitg-date.vala"
		_tmp32_ = _tmp31_->message;
#line 135 "../libgitg/gitg-date.vala"
		_tmp33_ = string_to_string (_tmp32_);
#line 135 "../libgitg/gitg-date.vala"
		_tmp34_ = g_strconcat ("Failed to compile date regex: ", _tmp33_, NULL);
#line 135 "../libgitg/gitg-date.vala"
		_tmp35_ = _tmp34_;
#line 135 "../libgitg/gitg-date.vala"
		g_warning ("gitg-date.vala:135: %s", _tmp35_);
#line 135 "../libgitg/gitg-date.vala"
		_g_free0 (_tmp35_);
#line 55 "../libgitg/gitg-date.vala"
		_g_error_free0 (e);
#line 1714 "gitg-date.c"
	}
	__finally32:
#line 55 "../libgitg/gitg-date.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 55 "../libgitg/gitg-date.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 55 "../libgitg/gitg-date.vala"
		g_clear_error (&_inner_error_);
#line 1723 "gitg-date.c"
	}
}


static void
gitg_date_g_initable_interface_init (GInitableIface * iface)
{
#line 28 "../libgitg/gitg-date.vala"
	gitg_date_g_initable_parent_iface = g_type_interface_peek_parent (iface);
#line 28 "../libgitg/gitg-date.vala"
	iface->init = (gboolean (*) (GInitable *, GCancellable*, GError**)) gitg_date_real_init;
#line 1735 "gitg-date.c"
}


static void
gitg_date_instance_init (GitgDate * self)
{
#line 28 "../libgitg/gitg-date.vala"
	self->priv = gitg_date_get_instance_private (self);
#line 1744 "gitg-date.c"
}


static void
gitg_date_finalize (GObject * obj)
{
	GitgDate * self;
#line 28 "../libgitg/gitg-date.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_DATE, GitgDate);
#line 262 "../libgitg/gitg-date.vala"
	_g_date_time_unref0 (self->priv->d_datetime);
#line 264 "../libgitg/gitg-date.vala"
	_g_free0 (self->priv->_date_string);
#line 28 "../libgitg/gitg-date.vala"
	G_OBJECT_CLASS (gitg_date_parent_class)->finalize (obj);
#line 1760 "gitg-date.c"
}


GType
gitg_date_get_type (void)
{
	static volatile gsize gitg_date_type_id__volatile = 0;
	if (g_once_init_enter (&gitg_date_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GitgDateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_date_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgDate), 0, (GInstanceInitFunc) gitg_date_instance_init, NULL };
		static const GInterfaceInfo g_initable_info = { (GInterfaceInitFunc) gitg_date_g_initable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType gitg_date_type_id;
		gitg_date_type_id = g_type_register_static (G_TYPE_OBJECT, "GitgDate", &g_define_type_info, 0);
		g_type_add_interface_static (gitg_date_type_id, g_initable_get_type (), &g_initable_info);
		GitgDate_private_offset = g_type_add_instance_private (gitg_date_type_id, sizeof (GitgDatePrivate));
		g_once_init_leave (&gitg_date_type_id__volatile, gitg_date_type_id);
	}
	return gitg_date_type_id__volatile;
}


static void
_vala_gitg_date_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	GitgDate * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_DATE, GitgDate);
#line 28 "../libgitg/gitg-date.vala"
	switch (property_id) {
#line 28 "../libgitg/gitg-date.vala"
		case GITG_DATE_DATE_STRING_PROPERTY:
#line 28 "../libgitg/gitg-date.vala"
		g_value_set_string (value, gitg_date_get_date_string (self));
#line 28 "../libgitg/gitg-date.vala"
		break;
#line 28 "../libgitg/gitg-date.vala"
		case GITG_DATE_DATE_PROPERTY:
#line 28 "../libgitg/gitg-date.vala"
		g_value_set_boxed (value, gitg_date_get_date (self));
#line 28 "../libgitg/gitg-date.vala"
		break;
#line 1803 "gitg-date.c"
		default:
#line 28 "../libgitg/gitg-date.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../libgitg/gitg-date.vala"
		break;
#line 1809 "gitg-date.c"
	}
}


static void
_vala_gitg_date_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	GitgDate * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_DATE, GitgDate);
#line 28 "../libgitg/gitg-date.vala"
	switch (property_id) {
#line 28 "../libgitg/gitg-date.vala"
		case GITG_DATE_DATE_STRING_PROPERTY:
#line 28 "../libgitg/gitg-date.vala"
		gitg_date_set_date_string (self, g_value_get_string (value));
#line 28 "../libgitg/gitg-date.vala"
		break;
#line 1830 "gitg-date.c"
		default:
#line 28 "../libgitg/gitg-date.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../libgitg/gitg-date.vala"
		break;
#line 1836 "gitg-date.c"
	}
}



